﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;

namespace WebfleetConnect
{
  public class ConfigRepo
  {

    public static Settings LoadSetings()
    {
      string folder = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\" + Application.ProductName;
      string fileName = folder + "\\settings.dat";
      try
      {
        using (FileStream fs = File.OpenRead(fileName))
        {
          BinaryFormatter formatter = new BinaryFormatter();
          Settings settings = (Settings)formatter.Deserialize(fs);
          settings.wasLoaded = true;
          return settings;
        }
      }
      catch (Exception)
      {
        // ignore. maybe there's no settings file
        return null;
      }
    }


    public static void SaveState(Settings settings)
    {
      try
      {
        string folder = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\" + Application.ProductName;
        if (!Directory.Exists(folder))
        {
          Directory.CreateDirectory(folder);
        }
        string fileName = folder + "\\settings.dat";

        using (FileStream fs = File.Create(fileName))
        {
          BinaryFormatter formatter = new BinaryFormatter();
          formatter.Serialize(fs, settings);
        }
      }
      catch (Exception)
      {
        // ignore to allow graceful application close
      }
    }
  }
}
